From 53ba97613274585b0eff6ee77b5e79c57195603f Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sat, 24 Feb 2024 05:19:04 +0200
Subject: [PATCH 34/34] trident: Add Nets

Graphics by Elefant

See RM #259

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/trident.tilespec   |   1 +
 data/trident/tiles.png  | Bin 82215 -> 141835 bytes
 data/trident/tiles.spec |   2 ++
 3 files changed, 3 insertions(+)

diff --git a/data/trident.tilespec b/data/trident.tilespec
index dfbfbe3c8c..6cd9f09563 100644
--- a/data/trident.tilespec
+++ b/data/trident.tilespec
@@ -342,6 +342,7 @@ styles =
       "tx.mine",       "Single1"
       "tx.oil_mine",   "Single1"
       "tx.oil_rig",    "Single1"
+      "tx.nets",       "Single1"
       "tx.pollution",  "Single2"
       "tx.fallout",    "Single2"
       "tx.village",    "Single1"
diff --git a/data/trident/tiles.png b/data/trident/tiles.png
index 219505d8d6644da7ba08fd92634de00137960e80..23ac472ff30c4b3abf9352c42425603ba70cf05a 100644
GIT binary patch
diff --git a/data/trident/tiles.spec b/data/trident/tiles.spec
index 90e8012f49..fbeb61aedb 100644
--- a/data/trident/tiles.spec
+++ b/data/trident/tiles.spec
@@ -14,6 +14,7 @@ artists = "
     Michael Johnson <justaguest> (nuke explosion)
     The Square Cow (inaccessible terrain)
     GriffonSpade
+    Elefant (Nets)
 "
 
 [file]
@@ -494,6 +495,7 @@ tiles = { "row", "column", "tag"
  16,  4, "tx.pollution"
  16,  5, "tx.fallout"
  16, 13, "tx.oil_rig"
+ 16, 14, "tx.nets"
 
 ; Bases
  16,  6, "base.buoy_mg"
-- 
2.43.0