From 210b4a4deb2f4a47b1fe3f88197b12c51c9a057b Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sat, 2 Mar 2024 05:13:01 +0200
Subject: [PATCH 5/5] Metainfo: Add developer name information

See RM #280

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 bootstrap/org.freeciv.gtk3.metainfo.xml.in    | 3 +++
 bootstrap/org.freeciv.gtk3.mp.metainfo.xml.in | 3 +++
 bootstrap/org.freeciv.gtk322.metainfo.xml.in  | 3 +++
 bootstrap/org.freeciv.gtk4.metainfo.xml.in    | 3 +++
 bootstrap/org.freeciv.gtk4.mp.metainfo.xml.in | 3 +++
 bootstrap/org.freeciv.qt.metainfo.xml.in      | 3 +++
 bootstrap/org.freeciv.qt.mp.metainfo.xml.in   | 3 +++
 bootstrap/org.freeciv.ruledit.metainfo.xml.in | 3 +++
 bootstrap/org.freeciv.sdl2.metainfo.xml.in    | 3 +++
 bootstrap/org.freeciv.server.metainfo.xml.in  | 3 +++
 10 files changed, 30 insertions(+)

diff --git a/bootstrap/org.freeciv.gtk3.metainfo.xml.in b/bootstrap/org.freeciv.gtk3.metainfo.xml.in
index 31bb937c04..9f485287d7 100644
--- a/bootstrap/org.freeciv.gtk3.metainfo.xml.in
+++ b/bootstrap/org.freeciv.gtk3.metainfo.xml.in
@@ -4,6 +4,9 @@
     <id>org.freeciv.gtk3</id>
     <project_license>GPL-2.0-or-later</project_license>
     <metadata_license>CC0</metadata_license>
+    <developer id="org.freeciv">
+      <name>Freeciv Team</name>
+    </developer>
     <summary>Gtk+-3 based client for the Freeciv game</summary>
     <description>
         <p>
diff --git a/bootstrap/org.freeciv.gtk3.mp.metainfo.xml.in b/bootstrap/org.freeciv.gtk3.mp.metainfo.xml.in
index 3c5a87c82a..d2ddf8314c 100644
--- a/bootstrap/org.freeciv.gtk3.mp.metainfo.xml.in
+++ b/bootstrap/org.freeciv.gtk3.mp.metainfo.xml.in
@@ -4,6 +4,9 @@
     <id>org.freeciv.gtk3.mp</id>
     <project_license>GPL-2.0-or-later</project_license>
     <metadata_license>CC0</metadata_license>
+    <developer id="org.freeciv">
+      <name>Freeciv Team</name>
+    </developer>
     <summary>Gtk+-3 based modpack installer for the Freeciv game</summary>
     <description>
         <p>
diff --git a/bootstrap/org.freeciv.gtk322.metainfo.xml.in b/bootstrap/org.freeciv.gtk322.metainfo.xml.in
index e672178ca2..a61882f711 100644
--- a/bootstrap/org.freeciv.gtk322.metainfo.xml.in
+++ b/bootstrap/org.freeciv.gtk322.metainfo.xml.in
@@ -4,6 +4,9 @@
     <id>org.freeciv.gtk322</id>
     <project_license>GPL-2.0-or-later</project_license>
     <metadata_license>CC0</metadata_license>
+    <developer id="org.freeciv">
+      <name>Freeciv Team</name>
+    </developer>
     <summary>Gtk+-3.22 based client for the Freeciv game</summary>
     <description>
         <p>
diff --git a/bootstrap/org.freeciv.gtk4.metainfo.xml.in b/bootstrap/org.freeciv.gtk4.metainfo.xml.in
index d6c79e4800..0348f840cf 100644
--- a/bootstrap/org.freeciv.gtk4.metainfo.xml.in
+++ b/bootstrap/org.freeciv.gtk4.metainfo.xml.in
@@ -4,6 +4,9 @@
     <id>org.freeciv.gtk4</id>
     <project_license>GPL-2.0-or-later</project_license>
     <metadata_license>CC0</metadata_license>
+    <developer id="org.freeciv">
+      <name>Freeciv Team</name>
+    </developer>
     <summary>Gtk4 based client for the Freeciv game</summary>
     <description>
         <p>
diff --git a/bootstrap/org.freeciv.gtk4.mp.metainfo.xml.in b/bootstrap/org.freeciv.gtk4.mp.metainfo.xml.in
index 65f5c93d58..be93f16867 100644
--- a/bootstrap/org.freeciv.gtk4.mp.metainfo.xml.in
+++ b/bootstrap/org.freeciv.gtk4.mp.metainfo.xml.in
@@ -4,6 +4,9 @@
     <id>org.freeciv.gtk4.mp</id>
     <project_license>GPL-2.0-or-later</project_license>
     <metadata_license>CC0</metadata_license>
+    <developer id="org.freeciv">
+      <name>Freeciv Team</name>
+    </developer>
     <summary>Gtk-4 based modpack installer for the Freeciv game</summary>
     <description>
         <p>
diff --git a/bootstrap/org.freeciv.qt.metainfo.xml.in b/bootstrap/org.freeciv.qt.metainfo.xml.in
index 1cd8d60011..4754fa2b3a 100644
--- a/bootstrap/org.freeciv.qt.metainfo.xml.in
+++ b/bootstrap/org.freeciv.qt.metainfo.xml.in
@@ -4,6 +4,9 @@
     <id>org.freeciv.qt</id>
     <project_license>GPL-2.0-or-later</project_license>
     <metadata_license>CC0</metadata_license>
+    <developer id="org.freeciv">
+      <name>Freeciv Team</name>
+    </developer>
     <summary>Qt based client for the Freeciv game</summary>
     <description>
         <p>
diff --git a/bootstrap/org.freeciv.qt.mp.metainfo.xml.in b/bootstrap/org.freeciv.qt.mp.metainfo.xml.in
index f1445dfbef..442b1c01ec 100644
--- a/bootstrap/org.freeciv.qt.mp.metainfo.xml.in
+++ b/bootstrap/org.freeciv.qt.mp.metainfo.xml.in
@@ -4,6 +4,9 @@
     <id>org.freeciv.qt.mp</id>
     <project_license>GPL-2.0-or-later</project_license>
     <metadata_license>CC0</metadata_license>
+    <developer id="org.freeciv">
+      <name>Freeciv Team</name>
+    </developer>
     <summary>Qt based modpack installer for the Freeciv game</summary>
     <description>
         <p>
diff --git a/bootstrap/org.freeciv.ruledit.metainfo.xml.in b/bootstrap/org.freeciv.ruledit.metainfo.xml.in
index 9d26453240..24cdfaea9d 100644
--- a/bootstrap/org.freeciv.ruledit.metainfo.xml.in
+++ b/bootstrap/org.freeciv.ruledit.metainfo.xml.in
@@ -4,6 +4,9 @@
     <id>org.freeciv.ruledit</id>
     <project_license>GPL-2.0-or-later</project_license>
     <metadata_license>CC0</metadata_license>
+    <developer id="org.freeciv">
+      <name>Freeciv Team</name>
+    </developer>
     <summary>Ruleset editor for the Freeciv game</summary>
     <description>
         <p>
diff --git a/bootstrap/org.freeciv.sdl2.metainfo.xml.in b/bootstrap/org.freeciv.sdl2.metainfo.xml.in
index 1a32fba3df..ffa3f78d66 100644
--- a/bootstrap/org.freeciv.sdl2.metainfo.xml.in
+++ b/bootstrap/org.freeciv.sdl2.metainfo.xml.in
@@ -4,6 +4,9 @@
     <id>org.freeciv.sdl2</id>
     <project_license>GPL-2.0-or-later</project_license>
     <metadata_license>CC0</metadata_license>
+    <developer id="org.freeciv">
+      <name>Freeciv Team</name>
+    </developer>
     <summary>SDL2 based client for the Freeciv game</summary>
     <description>
         <p>
diff --git a/bootstrap/org.freeciv.server.metainfo.xml.in b/bootstrap/org.freeciv.server.metainfo.xml.in
index 5c4723afbc..4cc3c0c0b6 100644
--- a/bootstrap/org.freeciv.server.metainfo.xml.in
+++ b/bootstrap/org.freeciv.server.metainfo.xml.in
@@ -4,6 +4,9 @@
     <id>org.freeciv.server</id>
     <project_license>GPL-2.0-or-later</project_license>
     <metadata_license>CC0</metadata_license>
+    <developer id="org.freeciv">
+      <name>Freeciv Team</name>
+    </developer>
     <summary>Server component for the Freeciv game</summary>
     <description>
         <p>
-- 
2.43.0