From 294317c145c83dc9f9f9e7b179ada6fd2f11c5f9 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sat, 2 Mar 2024 04:27:20 +0200
Subject: [PATCH 09/20] Add Toki Ponan nation

Ruleset by _Rorr404, with minor adjustment by me

See RM #279

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/default/nationlist.ruleset      |   1 +
 data/flags/Makefile.am               |   5 ++
 data/flags/tokipona-large.png        | Bin 0 -> 940 bytes
 data/flags/tokipona-shield-large.png | Bin 0 -> 575 bytes
 data/flags/tokipona-shield.png       | Bin 0 -> 449 bytes
 data/flags/tokipona.png              | Bin 0 -> 645 bytes
 data/flags/tokipona.svg              |  76 +++++++++++++++++++++++++
 data/misc/flags-large.spec           |   1 +
 data/misc/flags.spec                 |   2 +
 data/misc/shields-large.spec         |   1 +
 data/misc/shields.spec               |   1 +
 data/nation/Makefile.am              |   1 +
 data/nation/tokiponan.ruleset        |  80 +++++++++++++++++++++++++++
 meson.build                          |   2 +
 translations/nations/POTFILES.in     |   1 +
 15 files changed, 171 insertions(+)
 create mode 100644 data/flags/tokipona-large.png
 create mode 100644 data/flags/tokipona-shield-large.png
 create mode 100644 data/flags/tokipona-shield.png
 create mode 100644 data/flags/tokipona.png
 create mode 100644 data/flags/tokipona.svg
 create mode 100644 data/nation/tokiponan.ruleset

diff --git a/data/default/nationlist.ruleset b/data/default/nationlist.ruleset
index 0cee65e403..a5ac1b7391 100644
--- a/data/default/nationlist.ruleset
+++ b/data/default/nationlist.ruleset
@@ -626,6 +626,7 @@ default_nationset = "all"
 *include "nation/timurid.ruleset"
 *include "nation/tocharian.ruleset"
 *include "nation/togolese.ruleset"
+*include "nation/tokiponan.ruleset"
 *include "nation/toltec.ruleset"
 *include "nation/tongan.ruleset"
 *include "nation/transnistrian.ruleset"
diff --git a/data/flags/Makefile.am b/data/flags/Makefile.am
index a9c68bd201..181453d1f6 100644
--- a/data/flags/Makefile.am
+++ b/data/flags/Makefile.am
@@ -518,6 +518,7 @@ flag_files =				\
 		timur.png		\
 		tocharian.png		\
 		togo.png		\
+		tokipona.png		\
 		toltec.png		\
 		tonga.png		\
 		transnistria.png	\
@@ -1093,6 +1094,7 @@ flag_files =				\
 		timur-large.png		\
 		tocharian-large.png		\
 		togo-large.png		\
+		tokipona-large.png		\
 		toltec-large.png		\
 		tonga-large.png		\
 		transnistria-large.png		\
@@ -1669,6 +1671,7 @@ shield_files =					\
 		tibet-shield.png		\
 		timur-shield.png		\
 		togo-shield.png			\
+		tokipona-shield.png		\
 		toltec-shield.png		\
 		tocharian-shield.png		\
 		tonga-shield.png		\
@@ -2244,6 +2247,7 @@ shield_files =					\
 		tibet-shield-large.png		\
 		timur-shield-large.png		\
 		togo-shield-large.png			\
+		tokipona-shield-large.png		\
 		toltec-shield-large.png		\
 		tocharian-shield-large.png		\
 		tonga-shield-large.png		\
@@ -2822,6 +2826,7 @@ svg_files = 				\
 		timur.svg		\
 		tocharian.svg		\
 		togo.svg		\
+		tokipona.svg		\
 		toltec.svg		\
 		tonga.svg		\
 		transnistria.svg	\
diff --git a/data/flags/tokipona-large.png b/data/flags/tokipona-large.png
new file mode 100644
index 0000000000000000000000000000000000000000..0ce681506add639ccb039e2993a45a5470b1bddc
GIT binary patch
diff --git a/data/flags/tokipona-shield-large.png b/data/flags/tokipona-shield-large.png
new file mode 100644
index 0000000000000000000000000000000000000000..55ef1c864837b162de1280fca791b2ecd36fe9a8
GIT binary patch
diff --git a/data/flags/tokipona-shield.png b/data/flags/tokipona-shield.png
new file mode 100644
index 0000000000000000000000000000000000000000..39b69b3cdae0360e0548e22c16c589c8b1faf4cf
GIT binary patch
diff --git a/data/flags/tokipona.png b/data/flags/tokipona.png
new file mode 100644
index 0000000000000000000000000000000000000000..919b952ac06acd267c0b34bfac7a4ac9191ede15
GIT binary patch
diff --git a/data/flags/tokipona.svg b/data/flags/tokipona.svg
new file mode 100644
index 0000000000..d0bea782f3
--- /dev/null
+++ b/data/flags/tokipona.svg
@@ -0,0 +1,76 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg
+   width="600"
+   height="400"
+   version="1.1"
+   id="svg838"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:svg="http://www.w3.org/2000/svg">
+  <defs
+     id="defs842" />
+  <rect
+     style="fill:#c8e1ed;fill-opacity:1.0;stroke-width:5.66929;stroke-linecap:round;stroke-linejoin:bevel;stop-color:#000000"
+     id="rect4684"
+     width="600"
+     height="400"
+     x="0"
+     y="0" />
+  <g
+     transform="matrix(0.33755415,0,0,-0.33755415,188.33065,342.42618)"
+     fill="#000099"
+     stroke="none"
+     id="g1364">
+    <g
+       id="g1755"
+       transform="matrix(1.0249506,0,0,1.0249506,-8.2541353,-9.3390257)">
+      <path
+         fill="#000099"
+         stroke="none"
+         d="m 302,838 c -14,-14 -16,-126 -3,-147 5,-8 16,-11 25,-8 12,5 16,21 16,71 0,89 -10,112 -38,84 z"
+         id="path1352"
+         style="fill:#11119a;fill-opacity:1" />
+      <path
+         fill="#000099"
+         stroke="none"
+         d="m 521,775 c -27,-57 -32,-108 -10,-113 18,-3 84,122 75,144 -11,30 -44,15 -65,-31 z"
+         id="path1354"
+         style="fill:#11119a;fill-opacity:1" />
+      <path
+         fill="#000099"
+         stroke="none"
+         d="M 34,797 C 26,775 93,639 110,643 148,650 99,810 59,810 48,810 37,804 34,797 Z"
+         id="path1356"
+         style="fill:#11119a;fill-opacity:1" />
+      <path
+         fill="#000099"
+         stroke="none"
+         d="M 254,590 C 204,583 126,538 79,490 -19,390 14,144 136,67 199,27 243,17 336,23 c 125,7 212,62 275,172 53,92 32,220 -51,317 -62,71 -170,99 -306,78 z"
+         id="path1358"
+         style="fill:#11119a;fill-opacity:1" />
+      <path
+         fill="#ffff63"
+         stroke="none"
+         d="M 443,539 C 490,526 555,469 581,419 605,371 607,272 584,229 562,186 502,121 467,104 330,33 190,49 116,145 77,197 65,237 65,320 c 1,77 19,113 82,161 80,63 198,86 296,58 z"
+         id="path1360"
+         style="fill:#ffff77;fill-opacity:1" />
+      <path
+         fill="#000099"
+         stroke="none"
+         d="m 462,367 c -5,-7 -15,-28 -21,-48 -21,-67 -100,-120 -144,-98 -30,15 -65,56 -88,102 -21,40 -51,48 -57,14 -5,-26 53,-111 96,-141 89,-62 204,-7 252,119 15,40 -15,81 -38,52 z"
+         id="path1362"
+         style="fill:#11119a;fill-opacity:1" />
+    </g>
+  </g>
+</svg>
+<!--
+	len pi toki pona
+	
+	COPYRIGHT:
+	Spencer van der Meulen (jan Pensa) ©2021
+	Licence: Creative Commons Attribution-ShareAlike 4.0 International (CC BY-SA 4.0)
+	Based on:
+	- original logo design by Sonja Lang.
+	- Toki Pona logo vector image from https://commons.wikimedia.org/wiki/File:Toki_pona.svg by Eequor.
+	- colors from image on https://www.teepublic.com/user/toki-pona by Sonja Lang.
+-->
+
diff --git a/data/misc/flags-large.spec b/data/misc/flags-large.spec
index 2ce600a892..07cb84fa16 100644
--- a/data/misc/flags-large.spec
+++ b/data/misc/flags-large.spec
@@ -527,6 +527,7 @@ sprites =
 		"f.timur", "flags/timur-large"
 		"f.tocharian", "flags/tocharian-large"
 		"f.togo", "flags/togo-large"
+                "f.tokipona", "flags/tokipona-large"
 		"f.toltec", "flags/toltec-large"
 		"f.tonga", "flags/tonga-large"
 		"f.transnistria", "flags/transnistria-large"
diff --git a/data/misc/flags.spec b/data/misc/flags.spec
index d1d7a01086..3274c22da5 100644
--- a/data/misc/flags.spec
+++ b/data/misc/flags.spec
@@ -524,6 +524,7 @@ artists = "
    Timur		Daniel Markstedt
    Tocharian		Dan Cottrell and Daniel Markstedt
    Togo			Vzb83 and Madden (Wikimedia Commons)
+   Tokipona             Wikimedia Commons
    Toltec		J.M. Maalderink
    Tonga		Madden (Wikimedia Commons)
    Transnistria		Sigge Kotliar and J.M. Maalderink
@@ -1104,6 +1105,7 @@ sprites =
 		"f.timur", "flags/timur"
 		"f.tocharian", "flags/tocharian"
 		"f.togo", "flags/togo"
+                "f.tokipona", "flags/tokipona"
 		"f.toltec", "flags/toltec"
 		"f.tonga", "flags/tonga"
 		"f.transnistria", "flags/transnistria"
diff --git a/data/misc/shields-large.spec b/data/misc/shields-large.spec
index 7f15b180b8..494664b58f 100644
--- a/data/misc/shields-large.spec
+++ b/data/misc/shields-large.spec
@@ -527,6 +527,7 @@ sprites =
 		"f.shield.timur", "flags/timur-shield-large"
 		"f.shield.tocharian", "flags/tocharian-shield-large"
 		"f.shield.togo", "flags/togo-shield-large"
+                "f.shield.tokipona", "flags/tokipona-shield-large"
 		"f.shield.toltec", "flags/toltec-shield-large"
 		"f.shield.tonga", "flags/tonga-shield-large"
 		"f.shield.transnistria", "flags/transnistria-shield-large"
diff --git a/data/misc/shields.spec b/data/misc/shields.spec
index 84cf198044..1479a756b8 100644
--- a/data/misc/shields.spec
+++ b/data/misc/shields.spec
@@ -526,6 +526,7 @@ sprites =
 		"f.shield.timur", "flags/timur-shield"
 		"f.shield.tocharian", "flags/tocharian-shield"
 		"f.shield.togo", "flags/togo-shield"
+                "f.shield.tokipona", "flags/tokipona-shield"
 		"f.shield.toltec", "flags/toltec-shield"
 		"f.shield.tonga", "flags/tonga-shield"
 		"f.shield.transnistria", "flags/transnistria-shield"
diff --git a/data/nation/Makefile.am b/data/nation/Makefile.am
index d9499f4fc9..f229db31a3 100644
--- a/data/nation/Makefile.am
+++ b/data/nation/Makefile.am
@@ -512,6 +512,7 @@ pkgdata_DATA = \
 		timurid.ruleset \
 		tocharian.ruleset \
 		togolese.ruleset \
+		tokiponan.ruleset \
 		toltec.ruleset \
 		tongan.ruleset \
 		transnistrian.ruleset \
diff --git a/data/nation/tokiponan.ruleset b/data/nation/tokiponan.ruleset
new file mode 100644
index 0000000000..ad2f26722e
--- /dev/null
+++ b/data/nation/tokiponan.ruleset
@@ -0,0 +1,80 @@
+[nation_tokiponan]
+
+name   = _("Toki Ponan")
+plural = _("?plural:Toki Ponans")
+groups = "Imaginary"
+legend = _("Toki Pona is a conlang created by Sonja lang in 2001 which is\
+ notable for its extremely small size, consisting of 14 letters and anywhere\
+ from 120 words to 137 words.")
+
+leaders = {
+ "name",                        "sex"
+ "Sonja Lang",                  "Female"   ; Creator of the language.
+ "jan Misali",                  "Male"     ; Famous Toki Ponan youtuber.
+ "Jonathan Gabel",              "Male"     ; Creator of sitelen sitelen.
+}
+
+flag = "tokipona"
+flag_alt = "-"
+style = "European"
+
+init_techs = ""
+init_buildings = ""
+init_units = ""
+
+; Nations decided based on number of roots by language, Papua New Guinea for Tok Pisin.
+civilwar_nations = "papuanewguinean", "finnish", "serbian", "croatian", "esperant", "dutch", "acadian",
+"english", "georgian", "chinese", "cantonese"
+
+; List of cities and their Toki Ponan translations taken from:
+; https://github.com/jan-Lope/Toki_Pona-Parser/blob/master/toki-pona-unofficial-words-cities.pro
+; with minor corrections from wikipesija.org
+cities =
+ "Akajela",      ; Al-Qahirah, Kairo (Capital of Egypt) 
+ "Alana",        ; Atlanta (USA) 
+ "Alawa",        ; Ottawa (Capital of Canada) 
+ "Alenta",       ; Atlanta (USA) 
+ "Alipasi",      ; Halifax (Canada) 
+ "Anpu",         ; Hamburg (Germany) 
+ "Ansetan",      ; Amsterdam (Capital of Netherlands) 
+ "Asina",        ; Athen (Capital of Greece) 
+ "Esupo",        ; Espoo (Finland) 
+ "Iwesun",       ; Hilversum (Netherlands)  
+ "Kakawi",       ; Calgary (Canada) 
+ "Kenpisi",      ; Cambridge (USA, UK) 
+ "Kunte",        ; Krung Thep; Bangkok (Capital of Thailand) 
+ "Lantan",       ; London (Caiptal of UK)
+ "Lesinki",      ; Helsinki; Helsingfors (Capital of Finnland) 
+ "Loma",         ; Rome (Capital of Italy) 
+ "Losansele",    ; Los Angeles (USA) 
+ "Manten",       ; Moncton (Canada) 
+ "Mesiko",       ; Mexiko-Stadt (Capital of Mexiko) 
+ "Milano",       ; Milan (Italy) 
+ "Minsen",       ; Munich (Germany) 
+ "Monkela",      ; Montreal (Canada) 
+ "Napoli",       ; Napoli, Neapel (Italy) 
+ "Nujoka",       ; New York City (USA) 
+ "Osaka",        ; Osaka (Japan)  
+ "Paki",         ; Paris (Capital of France) 
+ "Pasen",        ; Boston (USA) 
+ "Pelin",        ; Berlin (Capital of Germany) 
+ "Peminan",      ; Birmingham (England)  
+ "Pesin",        ; Beijing; Peking (Capital of China) 
+ "Pilense",      ; Florenz (Italy) 
+ "Polan",        ; Portland (USA) 
+ "Putapesi",     ; Budapest (Capital of Hungary) 
+ "Sakata",       ; Jakarta (Capital of Indonesia) 
+ "Sanpansiko",   ; San Francisco (USA) 
+ "Sawi",         ; Sackville (Canada) 
+ "Sene",         ; Genf (Switzerland) 
+ "Sensan",       ; St. John"s (Canada) 
+ "Sesija",       ; Shediac (Canada) 
+ "Sije",         ; Dieppe (Canada) 
+ "Solu",         ; Seoul (Capital of South Korea) 
+ "Tanpele",      ; Tampere (Finland) 
+ "Telawi",       ; Tel Aviv (Israel) 
+ "Tokijo",       ; Tokyo; Tokio (Capital of Japan)  
+ "Towano",       ; Toronto (Canada) 
+ "Tuku",         ; Turku (Finland) 
+ "Wankuwa",      ; Vancouver (Canada) 
+ "Wenesija"      ; Venedig (Italy) 
diff --git a/meson.build b/meson.build
index b4fbf85f61..5a12c416cd 100644
--- a/meson.build
+++ b/meson.build
@@ -2038,6 +2038,7 @@ nations = [
   'timurid',
   'tocharian',
   'togolese',
+  'tokiponan',
   'toltec',
   'tongan',
   'transnistrian',
@@ -2833,6 +2834,7 @@ flags = [
   'timur',
   'tocharian',
   'togo',
+  'tokipona',
   'toltec',
   'tonga',
   'transnistria',
diff --git a/translations/nations/POTFILES.in b/translations/nations/POTFILES.in
index c0ba25e311..a9b00158b2 100644
--- a/translations/nations/POTFILES.in
+++ b/translations/nations/POTFILES.in
@@ -457,6 +457,7 @@ data/nation/tibetan.ruleset
 data/nation/timurid.ruleset
 data/nation/tocharian.ruleset
 data/nation/togolese.ruleset
+data/nation/tokiponan.ruleset
 data/nation/toltec.ruleset
 data/nation/tongan.ruleset
 data/nation/transnistrian.ruleset
-- 
2.43.0